/*****************************************************************************************
 * File name     : LOCAL.C
 * Author        : 
 * Module        : 
 * Purpose       : 
 * Create Date   : October 17, 2001 - 22:17
 * Modify history: 
 *****************************************************************************************
 */

#include <windows.h>
#include <commctrl.h>
#include "resource.h"
#include "local.h"
#include "inforecd.h"

/*****************************************************************************************
 * MACRO functions declare
 ****************************************************************************************/
#define mfIsEscapeChar(c)               ((c) == PACKETBEGINNER || (c) == '+' ||       \
                                         (c) == ESCAPECHAR || (c) == '3')
#define mfExpandEscapeChar(a, i, c)     {                                             \
                                          if (mfIsEscapeChar (c))                     \
                                          {                                           \
                                            (a)[(i)++] = ESCAPECHAR;                  \
                                            (a)[(i)++] = ~(c);                        \
                                          }                                           \
                                          else                                        \
                                            (a)[(i)++] = (c);                         \
                                        }

/*****************************************************************************************
 * Identifier constant declare
 ****************************************************************************************/
#define MAINWNDCLASSNAME                "YBD Local Controllor"
#define REGKEYYBDREPEATOR               "SOFTWARE\\YinBoDa\\Repeater"
#define PACKETBEGINNER                  0xa5
#define ESCAPECHAR                      0x1b

#define WM_PROPERTY                     (WM_USER+0x10)
#define WM_DISCONNECTED                 (WM_USER+0x11)
#define WM_STATUS                       (WM_USER+0x12)

#define DETECTQUESTION                  "9\r"
#define DETECTANSWER                    "YBDREPEATER\r"

/*****************************************************************************************
 * Data structure declare
 ****************************************************************************************/

/*****************************************************************************************
 * Local variable declare
 ****************************************************************************************/
static HINSTANCE  ghInst;
static HWND       ghWnd;
static HWND       ghDlg;
static BYTE       gbPort;

static HANDLE     ghCommDev = INVALID_HANDLE_VALUE;
static HANDLE     ghThread = NULL;

static DWORD      gdwCMDBytes = 0;
static BYTE       gabCMDBuf[5*256+2];

static CHAR       gaszRecvBuf[1024];
static WORD       gwRecvBytes = 0;

static BYTE       gbChannels, gbVersion, gbVoltage, gbPower1, gbPower2;
static BYTE       gbCurrent, gbTemperature;
static BYTE       gabGain[10*2];

#ifdef LOOPBACKDEBUG
static BYTE       gbLastCommand;
static BOOL       fEnableEcho = FALSE;
#endif

/*****************************************************************************************
 * Local functions declare
 ****************************************************************************************/

/****************************************************************************************/
BYTE LoadCommPort(void)
{
  HKEY            hKey;
  BYTE            bPort;
  DWORD           Result, dwLen, dwType;

  if (ERROR_SUCCESS == RegOpenKey (HKEY_LOCAL_MACHINE, REGKEYYBDREPEATOR, &hKey))
  {
    dwLen = sizeof bPort;
    Result = RegQueryValueEx (hKey, "Local Control Comm. Port", 0, &dwType, &bPort, &dwLen);
    if (Result != ERROR_SUCCESS) goto SetDefault;
    return bPort;
  }
SetDefault:
  return 1;
}
/****************************************************************************************/
BOOL SaveCommPort(BYTE bPort)
{
  HKEY            hKey;
  DWORD           Result;

  if (ERROR_SUCCESS == RegCreateKey (HKEY_LOCAL_MACHINE, REGKEYYBDREPEATOR, &hKey))
  {
    Result = RegSetValueEx (hKey, "Local Control Comm. Port", 0, REG_BINARY,
                            &bPort, sizeof bPort);
    if (Result != ERROR_SUCCESS) return FALSE;
  }
  return TRUE;
}
/****************************************************************************************/
BOOL ValidateField(HWND hDlg, WORD wCtrlID, LONG liMin, LONG liMax)
{
  CHAR            aszBuf[10];
  LONG            liValue;
  CHAR            aszString[256], aszString2[256];

  GetWindowText (GetDlgItem (hDlg, wCtrlID), aszBuf, sizeof aszBuf);
  liValue = atol (aszBuf);
  if (liValue>=liMin && liValue<=liMax)
    return TRUE;
  else
  {
    LoadString (ghInst, IDS_INVALIDVALUE, aszString, sizeof aszString);
    wsprintf (aszString2, aszString, liValue, liMin, liMax);
    LoadString (ghInst, IDS_PARAMETER_TITLE, aszString, sizeof aszString);
    MessageBox (hDlg, aszString2, aszString, MB_OK|MB_ICONERROR);
    SetFocus (GetDlgItem (hDlg, wCtrlID));
    SendDlgItemMessage (hDlg, wCtrlID, EM_SETSEL, 0, -1);
    return FALSE;
  }
}
/****************************************************************************************/
static BOOL OpenCommPort(int PortNo)
{
  char          Buf[100];
  DCB           dcb;
  COMMTIMEOUTS  CommTimeouts;


  if (PortNo < 1 || PortNo > 2) return FALSE;

  wsprintf (Buf, "COM%d", PortNo);

  ghCommDev = CreateFile (Buf, GENERIC_WRITE|GENERIC_READ, 0, NULL, OPEN_EXISTING, 0, NULL);
  if (ghCommDev != INVALID_HANDLE_VALUE)
  {
    wsprintf (Buf, "COM%d:baud=9600 parity=N data=8 stop=1", PortNo);
    if  (GetCommState (ghCommDev, &dcb))
    {
      //dcb.fDtrControl = RTS_CONTROL_ENABLE;
      //dcb.fRtsControl = RTS_CONTROL_DISABLE;
      if (BuildCommDCB (Buf, &dcb))
      {
        if (SetCommState (ghCommDev, &dcb))
        {
          memset (&CommTimeouts, 0, sizeof(COMMTIMEOUTS));
          CommTimeouts.ReadTotalTimeoutMultiplier = 2;
          if (SetCommTimeouts (ghCommDev, &CommTimeouts))
          {
            return TRUE;
          }
        }
      }
    }
    CloseHandle (ghCommDev);
  }
  return FALSE;
}
/****************************************************************************************/
static int CloseCommPort(void)
{
  HANDLE hHandle = ghCommDev;
  ghCommDev = INVALID_HANDLE_VALUE;
  return CloseHandle (hHandle);
}
/****************************************************************************************/
/****************************************************************************************/
#ifdef LOOPBACKDEBUG
/****************************************************************************************/
/****************************************************************************************/
#define ReadFile(hFile, pbBuf, dwBytes, pdwActBytes, lpOverlapped) \
        LoopBackReadFile (hFile, pbBuf, dwBytes, pdwActBytes, lpOverlapped)
#define WriteFile(hFile, pbBuf, dwBytes, pdwActBytes, lpOverlapped) \
        LoopBackWriteFile (hFile, pbBuf, dwBytes, pdwActBytes, lpOverlapped)
/****************************************************************************************/
BYTE    abLoopBackBuf[1024];
DWORD   dwLoopBackBufSize = 0;
/****************************************************************************************/
BOOL LoopBackReadFile(HANDLE hFile, PBYTE pbBuf, DWORD dwBytes, PDWORD pdwActBytes,
                      LPOVERLAPPED lpOverlapped)
{
  DWORD           i;

  if (dwLoopBackBufSize == 0)
    *pdwActBytes = 0;
  else if (dwLoopBackBufSize <= dwBytes)
  {
    memcpy (pbBuf, abLoopBackBuf, dwLoopBackBufSize);
    *pdwActBytes = dwLoopBackBufSize;
    for (i=0; i<dwLoopBackBufSize && gwRecvBytes < sizeof gaszRecvBuf; gwRecvBytes ++, i++)
      gaszRecvBuf[gwRecvBytes] = pbBuf[i];
    dwLoopBackBufSize = 0;
  }
  else
  {
    memcpy (pbBuf, abLoopBackBuf, dwBytes);
    *pdwActBytes = dwBytes;
    dwLoopBackBufSize -= dwBytes;
    memcpy (abLoopBackBuf, abLoopBackBuf+dwBytes, dwLoopBackBufSize);
    for (i=0; i<dwBytes && gwRecvBytes < sizeof gaszRecvBuf; gwRecvBytes ++, i++)
      gaszRecvBuf[gwRecvBytes] = pbBuf[i];
  }
  return TRUE;
}
/****************************************************************************************/
BOOL LoopBackWriteFile(HANDLE hFile, PBYTE pbBuf, DWORD dwBytes, PDWORD pdwActBytes,
                       LPOVERLAPPED lpOverlapped)
{
  BYTE            bLen, bCheckSum;
  BYTE            abTemp[100];
  DWORD           i;

  if (gwRecvBytes)
  {
    SpyShowData ("Repeater -> Controllor", gaszRecvBuf, gwRecvBytes, FALSE);
    gwRecvBytes = 0;
  }
  SpyShowData ("Controllor -> Repeater", pbBuf, dwBytes, FALSE);

  if (fEnableEcho)
  {
    if (strcmp (pbBuf, DETECTQUESTION) == 0)
    {
      strcpy (abLoopBackBuf+dwLoopBackBufSize, DETECTANSWER);
      dwLoopBackBufSize += sizeof DETECTANSWER;
    }
    else if (pbBuf[0] == PACKETBEGINNER)
    {
      switch (gbLastCommand)
      {
      case 4:
        bLen = 23;
        memcpy (abTemp, "\x82\xBE\x1B\x41\x00"
                        "\x30\xc0\x00\x00\x00\x11\x11\x1A\x00"
                        "\x30\x1F\x00\x00\x00\x11\x11\x00\x00", bLen);
/*
        abTemp[1] += (BYTE)(GetTickCount() & 0xf);
        abTemp[2] += (BYTE)(GetTickCount() & 0xf);
        abTemp[3] += (BYTE)(GetTickCount() & 0xf);
*/
        break;
      case 5:
        bLen = 12;
        memcpy (abTemp, "\x83\x02\x02\x1c\x14\x00\x14\x46\x5a\x5b\x5c\x5d", bLen);
       break;
      case 9:
        bLen = 12;
        memcpy (abTemp, "\x84""13600417512", bLen);
        break;
      default:
        bLen = 1;
        memcpy (abTemp, "\x80", bLen);
        break;
      }
      bCheckSum = 0;
      abLoopBackBuf[dwLoopBackBufSize++] = PACKETBEGINNER;
      mfExpandEscapeChar (abLoopBackBuf, dwLoopBackBufSize, bLen);
      for (i=0; i<bLen; i++)
      {
        bCheckSum += abTemp[i];
        mfExpandEscapeChar (abLoopBackBuf, dwLoopBackBufSize, abTemp[i]);
      }
      mfExpandEscapeChar (abLoopBackBuf, dwLoopBackBufSize, bCheckSum);
    }
  }
  *pdwActBytes = dwBytes;
  return TRUE;
}
/****************************************************************************************/
#else
/****************************************************************************************/
BOOL DebugReadFile(HANDLE hFile, PBYTE pbBuf, DWORD dwBytes, PDWORD pdwActBytes,
                   LPOVERLAPPED lpOverlapped)
{
  BOOL            fResult;
  DWORD           i;
  
  fResult = ReadFile (hFile, pbBuf, dwBytes, pdwActBytes, lpOverlapped);

  for (i=0; i<*pdwActBytes && gwRecvBytes < sizeof gaszRecvBuf; gwRecvBytes ++, i++)
    gaszRecvBuf[gwRecvBytes] = pbBuf[i];

  return fResult;
}
/****************************************************************************************/
BOOL DebugWriteFile(HANDLE hFile, PBYTE pbBuf, DWORD dwBytes, PDWORD pdwActBytes,
                        LPOVERLAPPED lpOverlapped)
{
  BOOL            fResult;

  if (gwRecvBytes)
  {
    SpyShowData ("Repeater -> Controllor", gaszRecvBuf, gwRecvBytes, FALSE);
    gwRecvBytes = 0;
  }

  fResult = WriteFile (hFile, pbBuf, dwBytes, pdwActBytes, lpOverlapped);
  SpyShowData ("Controllor -> Repeater", pbBuf, *pdwActBytes, FALSE);
  return fResult;
}
/****************************************************************************************/
#define ReadFile(hFile, pbBuf, dwBytes, pdwActBytes, lpOverlapped) \
        DebugReadFile (hFile, pbBuf, dwBytes, pdwActBytes, lpOverlapped)
#define WriteFile(hFile, pbBuf, dwBytes, pdwActBytes, lpOverlapped) \
        DebugWriteFile (hFile, pbBuf, dwBytes, pdwActBytes, lpOverlapped)
/****************************************************************************************/
#endif
/****************************************************************************************/
/****************************************************************************************/
static BOOL SendPacket(const BYTE *pcbPacket, BYTE bPacketSize)
{
  BYTE            abBuf[512];
  BYTE            bCheckSum;
  BYTE            bPos = 0, i;
  DWORD           dwActualLen;

  bCheckSum = 0;
  abBuf[bPos++] = PACKETBEGINNER;
  mfExpandEscapeChar (abBuf, bPos, bPacketSize);
  for (i=0; i<bPacketSize; i++)
  {
    bCheckSum += pcbPacket[i];
    mfExpandEscapeChar (abBuf, bPos, pcbPacket[i]);
  }
  mfExpandEscapeChar (abBuf, bPos, bCheckSum);
  
#ifdef LOOPBACKDEBUG
  gbLastCommand = pcbPacket[0];
#endif

  return WriteFile (ghCommDev, abBuf, bPos, &dwActualLen, NULL) && dwActualLen == bPos;
}
/****************************************************************************************/
static DWORD WINAPI CommunicationThread(LPVOID lpParameter)
{
  enum
  {
    MODE_DETECTREPEATER,
    MODE_QUERYMODULE,
    MODE_QUERYSTATUS
  }               Mode = MODE_DETECTREPEATER;
  const BYTE      aszDetectAnser[] = DETECTANSWER;
  WORD            wDetectPos = 0;
  BYTE            abBuf[512], bData, bCheckSum;
  WORD            wBufPos=2, wPacketSize = 1;
  BOOLEAN         fEscapeCharMode;
  DWORD           dwActualBytes;
  DWORD           dwSendTickCount = GetTickCount ();
  WORD            wSendCount = 0;
  DWORD           dwBytes;

  while (1)
  {
    if (!ReadFile (ghCommDev, &bData, 1, &dwActualBytes, NULL)) break;

    if (dwActualBytes == 1)
    {
      // Detect repeator
      if (aszDetectAnser[wDetectPos] == bData)
      {
        wDetectPos ++;
        if (!aszDetectAnser[wDetectPos])
        {
          Mode = MODE_QUERYMODULE;
          dwSendTickCount = GetTickCount () - 1000;
          wDetectPos = 0;
        }
      }
      else if (aszDetectAnser[0] == bData)
        wDetectPos = 1;
      else
        wDetectPos = 0;

      // Detect escape sequence
      if (bData == PACKETBEGINNER)
      {
        wPacketSize = 0;
        fEscapeCharMode = FALSE;
      }
      else
      {
        if (fEscapeCharMode)
        {
          bData = ~bData;
          fEscapeCharMode = FALSE;
        }
        else if (bData == ESCAPECHAR)
        {
          fEscapeCharMode = TRUE;
          continue;
        }
      
        if (wPacketSize == 0)
        {
          wPacketSize = bData;
          wBufPos     = 0;
          bCheckSum   = 0;
        }
        else
        {
          if (wBufPos == wPacketSize)
          {
            if (bCheckSum == bData)
            {
              wSendCount = 0;
              if (abBuf[0] == 0x82)
              {
                SendMessage (ghDlg, WM_STATUS, wPacketSize, (LPARAM)abBuf);
              }
              else if (abBuf[0] == 0x83)
              {
                SendMessage (ghDlg, WM_PROPERTY, wPacketSize, (LPARAM)abBuf);
                Mode = MODE_QUERYSTATUS;
                dwSendTickCount = GetTickCount () - 800;
              }
            }
            wBufPos ++;             
          }
          else if (wBufPos < wPacketSize)
            bCheckSum += abBuf[wBufPos++] = bData;
        }
      }
    }    
    
    if (wSendCount > 3)
    {
      Mode = MODE_DETECTREPEATER;
      SendMessage (ghDlg, WM_DISCONNECTED, 0, 0);
      wSendCount = 0;
    }

    if (GetTickCount () - dwSendTickCount > 800)
    {
      dwSendTickCount = GetTickCount ();

      while ((dwBytes=InterlockedExchange (&gdwCMDBytes, 0xffffffffl))==0xffffffffl);
      if (dwBytes)
      {
        if (!SendPacket (gabCMDBuf, (BYTE)dwBytes)) return 0;
      }
      else
      {
        switch (Mode)
        {
        case MODE_DETECTREPEATER:
          if (!WriteFile (ghCommDev, DETECTQUESTION, sizeof DETECTQUESTION, &dwActualBytes, NULL))
            return 0;
          break;
        case MODE_QUERYMODULE:
          if (!SendPacket ("\x05", 1)) return 0;
          wSendCount ++;
          break;
        case MODE_QUERYSTATUS:
          if (!SendPacket ("\x04", 1)) return 0;
          wSendCount ++;
          break;
        }
      }
      InterlockedExchange (&gdwCMDBytes, 0);
    }
  }
  return 0;
}
/****************************************************************************************/
static void CentreDialog(HWND hWnd)
{
  RECT            WndRect;
  int             x, y, w, h;

  GetWindowRect (hWnd, &WndRect);
  w = WndRect.right - WndRect.left;
  h = WndRect.bottom - WndRect.top;
  x = (GetSystemMetrics (SM_CXFULLSCREEN)-w)/2;
  y = (GetSystemMetrics (SM_CYFULLSCREEN)+20-h)/2;
  MoveWindow (hWnd, x, y, w, h, TRUE);
}
/****************************************************************************************/
static BOOL CALLBACK FactorySetProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  CHAR            aszString[256];
  DWORD           dwBytes;
  static BYTE     abSetPara[12];

  switch (uMsg)
  {
  case WM_INITDIALOG:
    CentreDialog (hDlg);
    wsprintf (aszString, "%d", gbChannels);
    SetWindowText (GetDlgItem (hDlg, IDC_FREQUENCY), aszString);
    wsprintf (aszString, "%d", gbVersion);
    SetWindowText (GetDlgItem (hDlg, IDC_VERSION), aszString);
    wsprintf (aszString, "%d", gbVoltage);
    SetWindowText (GetDlgItem (hDlg, IDC_VALTAGE), aszString);
    wsprintf (aszString, "%d", gbPower1);
    SetWindowText (GetDlgItem (hDlg, IDC_POWER1), aszString);
    wsprintf (aszString, "%d", gbPower2);
    SetWindowText (GetDlgItem (hDlg, IDC_POWER2), aszString);
    wsprintf (aszString, "%d", gbCurrent);
    SetWindowText (GetDlgItem (hDlg, IDC_CURRENT), aszString);
    wsprintf (aszString, "%d", gbTemperature);
    SetWindowText (GetDlgItem (hDlg, IDC_TEMPERATURE), aszString);
    wsprintf (aszString, "%d", gabGain[0]);
    SetWindowText (GetDlgItem (hDlg, IDC_GAIN1U), aszString);
    wsprintf (aszString, "%d", gabGain[1]);
    SetWindowText (GetDlgItem (hDlg, IDC_GAIN1D), aszString);
    wsprintf (aszString, "%d", gabGain[2]);
    SetWindowText (GetDlgItem (hDlg, IDC_GAIN2U), aszString);
    wsprintf (aszString, "%d", gabGain[3]);
    SetWindowText (GetDlgItem (hDlg, IDC_GAIN2D), aszString);
    return TRUE;
  case WM_COMMAND:
    switch (LOWORD (wParam))
    {
    case IDOK:
      abSetPara[0] = 0xfd;
      GetWindowText (GetDlgItem (hDlg, IDC_FREQUENCY), aszString, sizeof aszString);
      abSetPara[1] = (BYTE)atol (aszString);
      GetWindowText (GetDlgItem (hDlg, IDC_VERSION), aszString, sizeof aszString);
      abSetPara[2] = (BYTE)atol (aszString);
      GetWindowText (GetDlgItem (hDlg, IDC_VALTAGE), aszString, sizeof aszString);
      abSetPara[3] = (BYTE)atol (aszString);
      GetWindowText (GetDlgItem (hDlg, IDC_POWER1), aszString, sizeof aszString);
      abSetPara[4] = (BYTE)atol (aszString);
      GetWindowText (GetDlgItem (hDlg, IDC_POWER2), aszString, sizeof aszString);
      abSetPara[5] = (BYTE)atol (aszString);
      GetWindowText (GetDlgItem (hDlg, IDC_CURRENT), aszString, sizeof aszString);
      abSetPara[6] = (BYTE)atol (aszString);
      GetWindowText (GetDlgItem (hDlg, IDC_TEMPERATURE), aszString, sizeof aszString);
      abSetPara[7] = (BYTE)atol (aszString);
      GetWindowText (GetDlgItem (hDlg, IDC_GAIN1U), aszString, sizeof aszString);
      abSetPara[8] = (BYTE)atol (aszString);
      GetWindowText (GetDlgItem (hDlg, IDC_GAIN1D), aszString, sizeof aszString);
      abSetPara[9] = (BYTE)atol (aszString);
      GetWindowText (GetDlgItem (hDlg, IDC_GAIN2U), aszString, sizeof aszString);
      abSetPara[10] = (BYTE)atol (aszString);
      GetWindowText (GetDlgItem (hDlg, IDC_GAIN2D), aszString, sizeof aszString);
      abSetPara[11] = (BYTE)atol (aszString);

      while ((dwBytes=InterlockedExchange (&gdwCMDBytes, 0xffffffffl))==0xffffffffl);
      if (dwBytes && gabCMDBuf[0] != abSetPara[0])
      {
        LoadString (ghInst, IDS_BUFFERFULL, aszString, sizeof aszString);
        MessageBox (hDlg, aszString, "", MB_OK);
        InterlockedExchange (&gdwCMDBytes, dwBytes);
      }
      else
      {
        memcpy (gabCMDBuf, abSetPara, 12);
        InterlockedExchange (&gdwCMDBytes, 12);
      }
    case IDCANCEL:
      EndDialog (hDlg, LOWORD (wParam));
      break;
    }
    return TRUE;
  }
  return FALSE;
}
/****************************************************************************************/
static void FactorySet(HWND hWnd)
{
  DialogBox (ghInst, MAKEINTRESOURCE (IDD_FACTORYSET), hWnd, FactorySetProc);
}
/****************************************************************************************/
static BOOL CALLBACK MainDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  static BYTE     bCurSel;
  static BYTE     abSetPara[6*256+1];
  static BOOLEAN  fSetDefault = FALSE;
  static BOOLEAN  fConnected = FALSE;
  static BOOLEAN  fPower = TRUE;
  PBYTE           pbData;
  CHAR            aszString[256], aszBuf[256];
  LPNMUPDOWN      lpnmud;
  int             i, j;
  DWORD           dwThreadID;
  DWORD           dwBytes;

  switch (uMsg)
  {
  case WM_INITDIALOG:
    SendDlgItemMessage (hDlg, IDC_UPPOWERSB, SBM_SETRANGE, 0, 255);
    SendDlgItemMessage (hDlg, IDC_DOWNPOWERSB, SBM_SETRANGE, 0, 255);
    SendDlgItemMessage (hDlg, IDC_UPGAINSPIN, UDM_SETRANGE, 0, MAKELONG (31, 0));
    SendDlgItemMessage (hDlg, IDC_DOWNGAINSPIN, UDM_SETRANGE, 0, MAKELONG (31, 0));
    for (i=1; i<=4; i++)
    {
      wsprintf (aszString, "п%d", i);
      SendDlgItemMessage (hDlg, IDC_COMPORT, CB_ADDSTRING, 0, (LPARAM)aszString);
    }
    SendDlgItemMessage (hDlg, IDC_COMPORT, CB_SETCURSEL, gbPort-1, 0);
    return TRUE;
  case WM_NOTIFY:
    lpnmud = (LPNMUPDOWN)lParam;
    switch (wParam)
    {
    case IDC_UPGAINSPIN:
    case IDC_DOWNGAINSPIN:
      if (lpnmud->hdr.code == UDN_DELTAPOS)
        PostMessage (hDlg, WM_COMMAND, IDOK, 0);
      break;
    }
    break;
  case WM_HSCROLL:
    if ((HWND)lParam == GetDlgItem (hDlg, IDC_UPPOWERSB))
    {
      j = i = SendDlgItemMessage (hDlg, IDC_UPPOWERSB, SBM_GETPOS, 0, 0);
      switch (LOWORD (wParam))
      {
      case SB_LINELEFT:       if (i > 0) i--;     break;
      case SB_LINERIGHT:      if (i < 255) i++;   break;
      case SB_PAGELEFT:       i -= 10; if (i < 0) i = 0; break;
      case SB_PAGERIGHT:      i += 10; if (i > 255) i = 255; break;
      case SB_THUMBPOSITION:  i = HIWORD (wParam); break;
      }
      if (i != j)
      {
        SendDlgItemMessage (hDlg, IDC_UPPOWERSB, SBM_SETPOS, i, TRUE);
        PostMessage (hDlg, WM_COMMAND, IDOK, 0);
      }
    }
    else if ((HWND)lParam == GetDlgItem (hDlg, IDC_DOWNPOWERSB))
    {
      j = i = SendDlgItemMessage (hDlg, IDC_DOWNPOWERSB, SBM_GETPOS, 0, 0);
      switch (LOWORD (wParam))
      {
      case SB_LINELEFT:       if (i > 0) i--;     break;
      case SB_LINERIGHT:      if (i < 255) i++;   break;
      case SB_PAGELEFT:       i -= 10; if (i < 0) i = 0; break;
      case SB_PAGERIGHT:      i += 10; if (i > 255) i = 255; break;
      case SB_THUMBPOSITION:  i = HIWORD (wParam); break;
      }
      if (i != j)
      {
        SendDlgItemMessage (hDlg, IDC_DOWNPOWERSB, SBM_SETPOS, i, TRUE);
        PostMessage (hDlg, WM_COMMAND, IDOK, 0);
      }
    }
    break;
  case WM_COMMAND:
    switch (LOWORD (wParam))
    {
    case IDC_COMPORT:
      if (HIWORD (wParam) == CBN_SELCHANGE)
      {
        gbPort = (BYTE)SendDlgItemMessage (hDlg, IDC_COMPORT, CB_GETCURSEL, 0, 0)+1;
        TerminateThread (ghThread, 0);
        ghThread = NULL;
        CloseCommPort ();
        SendMessage (hDlg, WM_DISCONNECTED, 0, 0);
        if (!OpenCommPort (gbPort))
        {
          LoadString (ghInst, IDS_OPENSERIALERR, aszString, sizeof aszString);
          wsprintf (aszBuf, "%s %d", aszString, gbPort);
          MessageBox (NULL, aszBuf, "", MB_OK);
        }
        else
        {
          SaveCommPort (gbPort);
          ghThread = CreateThread (NULL, 0, CommunicationThread, NULL, 0, &dwThreadID);
        }
      }
      break;
    case IDC_CHANNEL:
      if (HIWORD (wParam) == CBN_SELCHANGE)
      {
        bCurSel = (BYTE)SendDlgItemMessage (hDlg, IDC_CHANNEL, CB_GETCURSEL, 0, 0);
        fSetDefault = TRUE;
      }
      break;
    case IDC_EXIT:
      DestroyWindow (ghWnd);
      break;
    case IDC_HELPINFO:
#ifdef LOOPBACKDEBUG
      fEnableEcho = !fEnableEcho;
#endif
      break;
    case IDC_POWER:
      if (HIWORD (wParam) == BN_CLICKED)
      {
        while ((dwBytes=InterlockedExchange (&gdwCMDBytes, 0xffffffffl))==0xffffffffl);
        if (dwBytes)
        {
          LoadString (ghInst, IDS_BUFFERFULL, aszString, sizeof aszString);
          MessageBox (hDlg, aszString, "", MB_OK);
          InterlockedExchange (&gdwCMDBytes, dwBytes);
        }
        else
        {
          if (fPower)
            memcpy (gabCMDBuf, "\x0b", 1);
          else
            memcpy (gabCMDBuf, "\x0a", 1);
          InterlockedExchange (&gdwCMDBytes, 1);
        }
      }
      break;
    case IDOK:
      if (HIWORD (wParam) == BN_CLICKED && fConnected)
      {
#ifdef CDMA
        if (!ValidateField (hDlg, IDC_FREQUENCY, 0, 333)) break;
#else
        if (!ValidateField (hDlg, IDC_FREQUENCY, 0, 125)) break;
#endif
        if (!ValidateField (hDlg, IDC_UPGAIN, 0, 31)) break;
        if (!ValidateField (hDlg, IDC_DOWNGAIN, 0, 31)) break;
        GetWindowText (GetDlgItem (hDlg, IDC_FREQUENCY), aszBuf, sizeof aszBuf);
#ifdef CDMA
        i = atol (aszBuf);
#else
        i = atol (aszBuf) + 0x180;
#endif
        abSetPara[bCurSel*6+1] = (BYTE)(i & 0xff);
        abSetPara[bCurSel*6+2] = (BYTE)((i >> 8) & 0xff);
        GetWindowText (GetDlgItem (hDlg, IDC_UPGAIN), aszBuf, sizeof aszBuf);
        abSetPara[bCurSel*6+3] = (BYTE)atol (aszBuf);
        GetWindowText (GetDlgItem (hDlg, IDC_DOWNGAIN), aszBuf, sizeof aszBuf);
        abSetPara[bCurSel*6+4] = (BYTE)atol (aszBuf);
        abSetPara[bCurSel*6+5] = (BYTE)SendDlgItemMessage (hDlg, IDC_UPPOWERSB, SBM_GETPOS, 0, 0);
        abSetPara[bCurSel*6+6] = (BYTE)SendDlgItemMessage (hDlg, IDC_DOWNPOWERSB, SBM_GETPOS, 0, 0);
        abSetPara[0] = 3;
        while ((dwBytes=InterlockedExchange (&gdwCMDBytes, 0xffffffffl))==0xffffffffl);
        if (dwBytes && gabCMDBuf[0] != abSetPara[0])
        {
          LoadString (ghInst, IDS_BUFFERFULL, aszString, sizeof aszString);
          MessageBox (hDlg, aszString, "", MB_OK);
          InterlockedExchange (&gdwCMDBytes, dwBytes);
        }
        else
        {
          memcpy (gabCMDBuf, abSetPara, gbChannels*6+1);
          InterlockedExchange (&gdwCMDBytes, gbChannels*6+1);
        }
      }
      break;
    case IDC_FREQUENCY:
      if (HIWORD (wParam) == EN_CHANGE)
      {
#ifdef CDMA
        if (ValidateField (hDlg, IDC_FREQUENCY, 0, 333))
#else
        if (ValidateField (hDlg, IDC_FREQUENCY, 0, 125))
#endif
        {
          GetWindowText (GetDlgItem (hDlg, IDC_FREQUENCY), aszBuf, sizeof aszBuf);
          if (strcmp (aszBuf, "YBD fS") == 0)
          {
            SetWindowText (GetDlgItem (hDlg, IDC_FREQUENCY), "0");
            FactorySet (hDlg);
          }
          else if (strcmp (aszBuf, "YBD cLR") == 0)
          {
            SetWindowText (GetDlgItem (hDlg, IDC_FREQUENCY), "0");
            while ((dwBytes=InterlockedExchange (&gdwCMDBytes, 0xffffffffl))==0xffffffffl);
            if (dwBytes && gabCMDBuf[0] != '\x0c')
            {
              LoadString (ghInst, IDS_BUFFERFULL, aszString, sizeof aszString);
              MessageBox (hDlg, aszString, "", MB_OK);
              InterlockedExchange (&gdwCMDBytes, dwBytes);
            }
            else
            {
              memcpy (gabCMDBuf, "\x0c", 1);
              InterlockedExchange (&gdwCMDBytes, 1);
            }
          }
          else
          {
            i = atol (aszBuf);
#ifdef CDMA
            wsprintf (aszString, "%u.%01u", i*3/100+825, i*3%100);
            SetWindowText (GetDlgItem (hDlg, IDC_UPFREQUENCY), aszString);
            wsprintf (aszString, "%u.%01u", i*3/100+870, i*3%100);
            SetWindowText (GetDlgItem (hDlg, IDC_DOWNFREQUENCY), aszString);
#else
            wsprintf (aszString, "%u.%01u", i/5+890, i%5*2);
            SetWindowText (GetDlgItem (hDlg, IDC_UPFREQUENCY), aszString);
            wsprintf (aszString, "%u.%01u", i/5+935, i%5*2);
            SetWindowText (GetDlgItem (hDlg, IDC_DOWNFREQUENCY), aszString);
#endif
          }
        }
      }
      break;
    case IDC_UPGAIN:
      if (HIWORD (wParam) == EN_CHANGE)
        ValidateField (hDlg, IDC_UPGAIN, 0, 31);
      break;
    case IDC_DOWNGAIN:
      if (HIWORD (wParam) == EN_CHANGE)
        ValidateField (hDlg, IDC_DOWNGAIN, 0, 31);
      break;
    }
    return TRUE;
  case WM_PROPERTY:
    gbChannels    = ((PBYTE)lParam)[1];
    gbVersion     = ((PBYTE)lParam)[2];
    gbVoltage     = ((PBYTE)lParam)[3];
    gbPower1      = ((PBYTE)lParam)[4];
    gbPower2      = ((PBYTE)lParam)[5];
    gbCurrent     = ((PBYTE)lParam)[6];
    gbTemperature = ((PBYTE)lParam)[7];
    for (i=0; i<gbChannels; i++)
    {
      gabGain[i*2  ] = ((PBYTE)lParam)[i*2+8];
      gabGain[i*2+1] = ((PBYTE)lParam)[i*2+9];
    }
    
    i = SendDlgItemMessage (hDlg, IDC_CHANNEL, CB_GETCOUNT, 0, 0);
    for (; i>0; i--)
      SendDlgItemMessage (hDlg, IDC_CHANNEL, CB_DELETESTRING, 0, 0);
    LoadString (ghInst, IDS_CHANNEL, aszString, sizeof aszString);
    for (i=1; i<=gbChannels; i++)
    {
      wsprintf (aszBuf, "%s %u", aszString, i);
      SendDlgItemMessage (hDlg, IDC_CHANNEL, CB_ADDSTRING, 0, (LPARAM)aszBuf);
    }
    bCurSel = 0;
    SendDlgItemMessage (hDlg, IDC_CHANNEL, CB_SETCURSEL, bCurSel, (LPARAM)aszBuf);
    LoadString (ghInst, IDS_POWEROFF, aszString, sizeof aszString);
    SetWindowText (GetDlgItem (hDlg, IDC_POWER), aszString);
    EnableWindow (GetDlgItem (hDlg, IDC_CHANNEL),      TRUE);
    EnableWindow (GetDlgItem (hDlg, IDC_FREQUENCY),    TRUE);
    EnableWindow (GetDlgItem (hDlg, IDC_UPGAIN),       TRUE);
    EnableWindow (GetDlgItem (hDlg, IDC_DOWNGAIN),     TRUE);
    EnableWindow (GetDlgItem (hDlg, IDC_UPGAINSPIN),   TRUE);
    EnableWindow (GetDlgItem (hDlg, IDC_DOWNGAINSPIN), TRUE);
    EnableWindow (GetDlgItem (hDlg, IDC_POWER),        TRUE);
    EnableWindow (GetDlgItem (hDlg, IDC_UPPOWERSB),    TRUE);
    EnableWindow (GetDlgItem (hDlg, IDC_DOWNPOWERSB),  TRUE);
    fConnected = TRUE;
    fSetDefault = TRUE;
    fPower = TRUE;
    return TRUE;
  case WM_DISCONNECTED:
    EnableWindow (GetDlgItem (hDlg, IDC_CHANNEL),      FALSE);
    EnableWindow (GetDlgItem (hDlg, IDC_FREQUENCY),    FALSE);
    EnableWindow (GetDlgItem (hDlg, IDC_UPGAIN),       FALSE);
    EnableWindow (GetDlgItem (hDlg, IDC_DOWNGAIN),     FALSE);
    EnableWindow (GetDlgItem (hDlg, IDC_UPGAINSPIN),   FALSE);
    EnableWindow (GetDlgItem (hDlg, IDC_DOWNGAINSPIN), FALSE);
    EnableWindow (GetDlgItem (hDlg, IDC_POWER),        FALSE);
    EnableWindow (GetDlgItem (hDlg, IDC_UPPOWERSB),    FALSE);
    EnableWindow (GetDlgItem (hDlg, IDC_DOWNPOWERSB),  FALSE);
    fConnected = FALSE;
    return TRUE;
  case WM_STATUS:
    pbData = (PBYTE)lParam;

    if (!fSetDefault)
    {
      for (i=0; i<gbChannels; i++)
      {
        if (abSetPara[i*6+1] != pbData[5+i*9+1]) break;  // Frequency
        if (abSetPara[i*6+2] != pbData[5+i*9+2]) break;
        if (abSetPara[i*6+3] != pbData[5+i*9+3]) break;  // Up Gain
        if (abSetPara[i*6+4] != pbData[5+i*9+4]) break;  // Down Gain
        if (abSetPara[i*6+5] != pbData[5+i*9+5]) break;  // Up Power
        if (abSetPara[i*6+6] != pbData[5+i*9+6]) break;  // Down Power
      }
      if (i<gbChannels)
        fSetDefault = TRUE;
    }
    if (fSetDefault)
    {
      for (i=0; i<gbChannels; i++)
      {
        abSetPara[i*6+1] = pbData[5+i*9+1];  // Frequency
        abSetPara[i*6+2] = pbData[5+i*9+2];
        abSetPara[i*6+3] = pbData[5+i*9+3];  // Up Gain
        abSetPara[i*6+4] = pbData[5+i*9+4];  // Down Gain
        abSetPara[i*6+5] = pbData[5+i*9+5];  // Up Power
        abSetPara[i*6+6] = pbData[5+i*9+6];  // Down Power
      }
    }
    
    i = pbData[1];
    i = gbVoltage*i*100/204+5;
    wsprintf (aszString, "%u.%u", i/100, i/10%10);
    SetWindowText (GetDlgItem (hDlg, IDC_VOLTAGE), aszString);

    i = pbData[2];
    i = gbCurrent*i*100/204+5;
    wsprintf (aszString, "%u.%u", i/100, i/10%10);
    SetWindowText (GetDlgItem (hDlg, IDC_CURRENT), aszString);

    i = pbData[3];
    i = gbTemperature*i*100/204+5;
    wsprintf (aszString, "%u.%u", i/100, i/10%10);
    SetWindowText (GetDlgItem (hDlg, IDC_TEMPERATURE), aszString);

    if (pbData[4] & 1)
      LoadString (ghInst, IDS_DOOROPEN, aszString, sizeof aszString);
    else
      LoadString (ghInst, IDS_DOORCLOSE, aszString, sizeof aszString);
    SetWindowText (GetDlgItem (hDlg, IDC_DOOR), aszString);

    if (fSetDefault || (pbData[4] & 8) && !fPower || !(pbData[4] & 8) && fPower)
    {
      fPower = (pbData[4] & 8) != 0;
      if (fPower)
        LoadString (ghInst, IDS_POWERON, aszString, sizeof aszString);
      else
        LoadString (ghInst, IDS_POWEROFF, aszString, sizeof aszString);
      SetWindowText (GetDlgItem (hDlg, IDC_POWER), aszString);
    }

    pbData += bCurSel*9+5;
    i = pbData[1] + pbData[2] * 256;
    if (i <= 333)
      i = i;
    else if (i >= 0x180 && i <= 0x180 + 125)
      i = i - 0x180;
    else
      i = 0;
    SendDlgItemMessage (hDlg, IDC_UPLOCK, BM_SETCHECK,
                        pbData[0] & 0x10 ? BST_UNCHECKED : BST_CHECKED, 0);
    SendDlgItemMessage (hDlg, IDC_DOWNLOCK, BM_SETCHECK,
                        pbData[0] & 0x20 ? BST_UNCHECKED : BST_CHECKED, 0);
#ifdef CDMA
    wsprintf (aszString, "%u.%01u", i*3/100+825, i*3%100);
    SetWindowText (GetDlgItem (hDlg, IDC_ACTUALUPFREQUENCY), aszString);
    wsprintf (aszString, "%u.%01u", i*3/100+870, i*3%100);
    SetWindowText (GetDlgItem (hDlg, IDC_ACTUALDOWNFREQUENCY), aszString);
#else
    wsprintf (aszString, "%u.%01u", i/5+890, i%5*2);
    SetWindowText (GetDlgItem (hDlg, IDC_ACTUALUPFREQUENCY), aszString);
    wsprintf (aszString, "%u.%01u", i/5+935, i%5*2);
    SetWindowText (GetDlgItem (hDlg, IDC_ACTUALDOWNFREQUENCY), aszString);
#endif
    wsprintf (aszString, "%u", gabGain[bCurSel*2  ]-pbData[3]);
    SetWindowText (GetDlgItem (hDlg, IDC_ACTUALUPGAIN), aszString);
    wsprintf (aszString, "%u", gabGain[bCurSel*2+1]-pbData[4]);
    SetWindowText (GetDlgItem (hDlg, IDC_ACTUALDOWNGAIN), aszString);
    j = pbData[7] * (gbPower1*10+gbPower2) * 10 / 204 + 5;
    wsprintf (aszString, "%u.%u", j/100, j/10%10);
    SetWindowText (GetDlgItem (hDlg, IDC_ACTUALUPPOWER), aszString);
    j = pbData[8] * (gbPower1*10+gbPower2) * 10 / 204 + 5;
    wsprintf (aszString, "%u.%u", j/100, j/10%10);
    SetWindowText (GetDlgItem (hDlg, IDC_ACTUALDOWNPOWER), aszString);

    if (fSetDefault)
    {
      SetFocus (GetDlgItem (hDlg, IDC_CHANNEL));

      wsprintf (aszString, "%u", i);
      SetWindowText (GetDlgItem (hDlg, IDC_FREQUENCY), aszString);
#ifdef CDMA
      wsprintf (aszString, "%u.%01u", i*3/100+825, i*3%100);
      SetWindowText (GetDlgItem (hDlg, IDC_UPFREQUENCY), aszString);
      wsprintf (aszString, "%u.%01u", i*3/100+870, i*3%100);
      SetWindowText (GetDlgItem (hDlg, IDC_DOWNFREQUENCY), aszString);
#else
      wsprintf (aszString, "%u.%01u", i/5+890, i%5*2);
      SetWindowText (GetDlgItem (hDlg, IDC_UPFREQUENCY), aszString);
      wsprintf (aszString, "%u.%01u", i/5+935, i%5*2);
      SetWindowText (GetDlgItem (hDlg, IDC_DOWNFREQUENCY), aszString);
#endif
      wsprintf (aszString, "%u", pbData[3]);
      SetWindowText (GetDlgItem (hDlg, IDC_UPGAIN), aszString);
      wsprintf (aszString, "%u", pbData[4]);
      SetWindowText (GetDlgItem (hDlg, IDC_DOWNGAIN), aszString);
      SendDlgItemMessage (hDlg, IDC_UPPOWERSB, SBM_SETPOS, pbData[5], TRUE);
      SendDlgItemMessage (hDlg, IDC_DOWNPOWERSB, SBM_SETPOS, pbData[6], TRUE);

      fSetDefault = FALSE;
    }
    return TRUE;
  }

  return FALSE;
}
/****************************************************************************************/
static LRESULT CALLBACK WindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  RECT            WndRect;
  RECT            DlgRect;
  switch (uMsg)
  {
  case WM_DESTROY:
    PostQuitMessage (0);
    break;
  case WM_SETFOCUS:
    SetFocus (ghDlg);
    break;
  case WM_SIZE:
    GetWindowRect (hWnd, &WndRect);
    GetClientRect (hWnd, &DlgRect);
    WndRect.right = WndRect.right - WndRect.left - DlgRect.right + DlgRect.left;
    WndRect.bottom = WndRect.bottom - WndRect.top - DlgRect.bottom + DlgRect.top;
    GetClientRect (ghDlg, &DlgRect);
    WndRect.right += DlgRect.right - DlgRect.left;
    WndRect.bottom += DlgRect.bottom - DlgRect.top;

    MoveWindow (hWnd, WndRect.left, WndRect.top, WndRect.right, WndRect.bottom, TRUE);
    return 0;
  }
  return DefWindowProc (hWnd, uMsg, wParam, lParam);
}
/****************************************************************************************/
int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nCmdShow)
{
  WNDCLASSEX      WndClass;
  MSG             Msg;
  RECT            WndRect;
  RECT            DlgRect;
  DWORD           dwThreadID;
  CHAR            aszString[256], aszBuf[256];
  INITCOMMONCONTROLSEX  ics;

  ics.dwSize = sizeof ics;
  ics.dwICC  = ICC_UPDOWN_CLASS ;
  if (!InitCommonControlsEx (&ics)) return 0;
  
  gbPort = LoadCommPort ();
  if (!OpenCommPort (gbPort))
  {
    LoadString (hInst, IDS_OPENSERIALERR, aszString, sizeof aszString);
    wsprintf (aszBuf, "%s %d", aszString, gbPort);
    MessageBox (NULL, aszBuf, "", MB_OK);
  }

  ghInst = hInst;
  SpyWindow ();

  WndClass.cbSize        = sizeof (WNDCLASSEX);
  WndClass.style         = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;
  WndClass.lpfnWndProc   = WindowProc;
  WndClass.cbClsExtra    = 0;
  WndClass.cbWndExtra    = 0;
  WndClass.hInstance     = hInst;
  WndClass.hIcon         = LoadIcon (hInst, MAKEINTRESOURCE (IDI_MAIN));
  WndClass.hCursor       = LoadCursor (NULL, IDC_ARROW);
  WndClass.hbrBackground = NULL;
  WndClass.lpszMenuName  = NULL;
  WndClass.lpszClassName = MAINWNDCLASSNAME;
  WndClass.hIconSm       = NULL;
  if (!RegisterClassEx (&WndClass)) return 0;

  ghWnd = CreateWindowEx (WS_EX_APPWINDOW, MAINWNDCLASSNAME, "ֱŻؼس",
                          WS_OVERLAPPEDWINDOW, 0, 0, 200, 100,
                          NULL, NULL, hInst, NULL);
  if (ghWnd == NULL) return 0;

  ghDlg = CreateDialog (hInst, MAKEINTRESOURCE (IDD_STATUS), ghWnd, MainDlgProc);
  if (ghDlg == NULL) return 0;
  ShowWindow (ghDlg, SW_SHOW);

  GetWindowRect (ghWnd, &WndRect);
  GetClientRect (ghWnd, &DlgRect);
  WndRect.right = WndRect.right - WndRect.left - DlgRect.right + DlgRect.left;
  WndRect.bottom = WndRect.bottom - WndRect.top - DlgRect.bottom + DlgRect.top;
  GetClientRect (ghDlg, &DlgRect);
  WndRect.right += DlgRect.right - DlgRect.left;
  WndRect.bottom += DlgRect.bottom - DlgRect.top;
  MoveWindow (ghWnd,
              (GetSystemMetrics (SM_CXFULLSCREEN)-WndRect.right)/2,
              (GetSystemMetrics (SM_CYFULLSCREEN)-WndRect.bottom)/2,
              WndRect.right, WndRect.bottom, TRUE);

  if (ghCommDev != INVALID_HANDLE_VALUE)
    ghThread = CreateThread (NULL, 0, CommunicationThread, NULL, 0, &dwThreadID);

  ShowWindow (ghWnd, nCmdShow);
  UpdateWindow (ghWnd);

  while (GetMessage (&Msg, NULL, 0, 0))
  {
    if (!IsDialogMessage (ghDlg, &Msg))
    {
      TranslateMessage (&Msg);
      DispatchMessage (&Msg);
    }
  }

  CloseCommPort ();
  return Msg.wParam;
}
/****************************************************************************************/
