#ifndef __ZFZPARAM_H
#define __ZFZPARAM_H

#define ZFZNAMELEN                      50
#define ZFZPHONELEN                     60
#define ZFZREMARKLEN                    100

typedef enum
{
  VWI_NORMAL,
  VWI_ERROR,
  VWI_INSTALL,
  VWI_CONNECT,
  VWI_TURNOFF,
} VIEWWNDIMAGE;

typedef enum
{
  ERRORCODE_NONE,
  ERRORCODE_ERRORS,
} ERRORCODE;

typedef enum
{
  TASKID_IDLE           = 0x00000000l,
  TASKID_SETPHONE1      = 0x00000001l,    // Centre phone number
  TASKID_SETPHONE2      = 0x00000002l,    // Self phone number
  TASKID_GETPHONE2      = 0x00000004l,
  TASKID_SETPARAM       = 0x00000008l,
  TASKID_GETPROPERTIES  = 0x00000010l,
  TASKID_ALARM          = 0x00000020l,
  TASKID_TURNON         = 0x00000040l,
  TASKID_TURNOFF        = 0x00000080l,
  TASKID_GETSTATUS      = 0x00000100l,
  TASKID_LOCK           = 0x00000200l,
  TASKID_UNLOCK         = 0x00000400l,
  TASKID_LOCKNODE       = 0x80000000l,    // Disable interface to modify the record
  TASKID_SYNCHRONIZE    = 0xffffffffl,
} TASKID;

typedef struct tagZFZDATE
{
  WORD            wYear;
  BYTE            bMonth;
  BYTE            bDay;
  BYTE            bHour;
  BYTE            bMinute;
} ZFZDATE, *PZFZDATE;

typedef struct tagZFZCHANNEL
{
  BYTE            bFrequency;
  BYTE            bUpGain;
  BYTE            bDownGain;
  BYTE            bUpPower;
  BYTE            bDownPower;
  BYTE            bErrorCode;
  BYTE            bActualUpPower;
  BYTE            bActualDownPower;
} ZFZCHANNEL, *ZFZPCHANNEL;

typedef struct tagZFZPARAM
{
  CHAR            aszName[ZFZNAMELEN+1];
  CHAR            aszPhone[ZFZPHONELEN+1];
  CHAR            aszRemark[ZFZREMARKLEN+1];
  BYTE            bChannels;
  ZFZDATE         CreateDate;
  ZFZDATE         LastAlarmDate;
  ZFZDATE         LastSamplingDate;
  BYTE            fDisableAlarm;
  BYTE            fPopupStatusDialog;
  BYTE            bVoltage;
  BYTE            bCurrent;
  BYTE            bTemperature;
  BYTE            bRatedVoltage;
  BYTE            bRatedCurrent;
  BYTE            bRatedTempture;
  BYTE            bRatedPower1;
  BYTE            bRatedPower2;
  ERRORCODE       ErrorCode;
  TASKID          TaskID;
  VIEWWNDIMAGE    VWImageIndex;
  BYTE            bDoorFlag;
  ZFZCHANNEL      ChannelData[1];
} ZFZPARAM, *PZFZPARAM;

#endif//__ZFZPARAM_H
