/*****************************************************************************************
 * File name     : UI.H
 * Author        : Skeleton Key
 * Module        : 
 * Purpose       : 
 * Create Date   : June 8, 2001 - 10:10
 * Modify history: 
 *****************************************************************************************
 */

#ifndef __UI_H
#define __UI_H

/*****************************************************************************************
 * Overview
 *****************************************************************************************
 * ==> To add your description <==
 ****************************************************************************************/

/*****************************************************************************************
 * MACRO functions declare
 ****************************************************************************************/

/*****************************************************************************************
 * Identifier constant declare
 ****************************************************************************************/
#define MAXATCMDLEN                     100

#define ZFZNAMELEN                      50
#define ZFZPHONELEN                     60
#define ZFZREMARKLEN                    100

/*****************************************************************************************
 * Data structure declare
 ****************************************************************************************/
typedef enum
{
  VWI_NORMAL,
  VWI_ERROR,
  VWI_INSTALL,
  VWI_CONNECT,
  VWI_TURNOFF,
} VIEWWNDIMAGE;

typedef enum
{
  TASKID_IDLE           = 0x00000000l,
  TASKID_SETPHONE1      = 0x00000001l,    // Centre phone number
  TASKID_SETPHONE2      = 0x00000002l,    // Self phone number
  TASKID_GETPHONE2      = 0x00000004l,
  TASKID_SETPARAM       = 0x00000008l,
  TASKID_GETPROPERTIES  = 0x00000010l,
  TASKID_ALARM          = 0x00000020l,
  TASKID_TURNON         = 0x00000040l,
  TASKID_TURNOFF        = 0x00000080l,
  TASKID_GETSTATUS      = 0x00000100l,
  TASKID_LOCK           = 0x00000200l,
  TASKID_UNLOCK         = 0x00000400l,
  TASKID_LOCKNODE       = 0x80000000l,    // Disable interface to modify the record
  TASKID_SYNCHRONIZE    = 0xffffffffl,
} TASKID;

typedef enum
{
  ERRORCODE_NONE,
  ERRORCODE_ERRORS,
} ERRORCODE;

typedef struct tagMODEMPARAM
{
  WORD            wCommPort;
  CHAR            aszInit[MAXATCMDLEN+1];
  CHAR            aszDial[MAXATCMDLEN+1];
  CHAR            aszAnswer[MAXATCMDLEN+1];
  CHAR            aszHangup[MAXATCMDLEN+1];
  CHAR            aszToCMD[MAXATCMDLEN+1];
} MODEMPARAM, *PMODEMPARAM;
typedef const MODEMPARAM* PCMODEMPARAM;

typedef struct tagZFZDATE
{
  WORD            wYear;
  BYTE            bMonth;
  BYTE            bDay;
  BYTE            bHour;
  BYTE            bMinute;
} ZFZDATE, *PZFZDATE;

typedef struct tagZFZCHANNEL
{
  WORD            wFrequency;
  BYTE            bUpGain;
  BYTE            bDownGain;
  BYTE            bUpPower;
  BYTE            bDownPower;
  BYTE            bErrorCode;
  BYTE            bActualUpPower;
  BYTE            bActualDownPower;
} ZFZCHANNEL, *ZFZPCHANNEL;

#if 0
typedef struct tagZFZPARAM_V1
{
  CHAR            aszName[ZFZNAMELEN+1];
  CHAR            aszPhone[ZFZPHONELEN+1];
  CHAR            aszRemark[ZFZREMARKLEN+1];
  BYTE            bChannels;
  ZFZDATE         CreateDate;
  ZFZDATE         LastAlarmDate;
  ZFZDATE         LastSamplingDate;
  BYTE            fDisableAlarm;
  BYTE            fPopupStatusDialog;
  BYTE            bVoltage;
  BYTE            bCurrent;
  BYTE            bTemperature;
  BYTE            bRatedVoltage;
  BYTE            bRatedCurrent;
  BYTE            bRatedTempture;
  BYTE            bRatedPower1;
  BYTE            bRatedPower2;
  ERRORCODE       ErrorCode;
  TASKID          TaskID;
  VIEWWNDIMAGE    VWImageIndex;
  BYTE            bDoorFlag;
  ZFZCHANNEL      ChannelData[1];
} ZFZPARAM_V1, *PZFZPARAM_V1;
#endif

typedef struct tagZFZPARAM
{
  CHAR            aszName[ZFZNAMELEN+1];
  CHAR            aszPhone[ZFZPHONELEN+1];
  CHAR            aszRemark[ZFZREMARKLEN+1];
  BYTE            bChannels;
  ZFZDATE         CreateDate;
  ZFZDATE         LastAlarmDate;
  ZFZDATE         LastSamplingDate;
  BYTE            fDisableAlarm;
  BYTE            fPopupStatusDialog;
  BYTE            bVoltage;
  BYTE            bCurrent;
  BYTE            bTemperature;
  BYTE            bRatedVoltage;
  BYTE            bRatedCurrent;
  BYTE            bRatedTempture;
  BYTE            bRatedPower1;
  BYTE            bRatedPower2;
  BYTE            bRatedGain;
  ERRORCODE       ErrorCode;
  TASKID          TaskID;
  TASKID          ExecutedTaskID;
  VIEWWNDIMAGE    VWImageIndex;
  BYTE            bStatusFlag;
  ZFZCHANNEL      ChannelData[1];
} ZFZPARAM, *PZFZPARAM;

typedef enum
{
  STFLAG_ALWAYSFOCUS   = 0x00000001l,
  STFLAG_TABSTOP       = 0x00000002l,
  STFLAG_IGNORETYPE    = 0x00000004l,
  STFLAG_EXPANDNEWLINE = 0x00000008l,
  STFLAG_INSPECTSTREAM = 0x80000000l,
} STFLAG;

typedef enum
{
  OMPT_SUCCESS,
  OMPT_ERROR,
  OMPT_INFO,
  OMPT_UPLOAD,
  OMPT_DOWNLOAD,
} OMPT;

typedef HWND (PASCAL *STATWND_CREATEWND)(HINSTANCE hInst, HWND hWndParent, STFLAG Flags);
typedef WORD (PASCAL *STATWND_STREAMBYTE)(HWND hWnd, OMPT Type, BYTE bVal);

/*****************************************************************************************
 * Global variable declare
 ****************************************************************************************/
#ifdef ALLOCATE_UI_VARIABLE_MEMORY
  #define UI_VARIABLE_EXTERN
#else
  #define UI_VARIABLE_EXTERN extern
#endif

UI_VARIABLE_EXTERN HINSTANCE  ghInst;
UI_VARIABLE_EXTERN HWND       ghMainWnd;
UI_VARIABLE_EXTERN MODEMPARAM gModemParam;
UI_VARIABLE_EXTERN CHAR       gaszCentrePhone[ZFZPHONELEN+1];
UI_VARIABLE_EXTERN HWND       ghDebugWnd;

UI_VARIABLE_EXTERN STATWND_CREATEWND  gpfunSTATWND_CreateWnd;
UI_VARIABLE_EXTERN STATWND_STREAMBYTE gpfunSTATWND_StreamByte;

/*****************************************************************************************
 * ==> To add your function declare <==
 *****************************************************************************************
 * ==> To describe the function <==
 *****************************************************************************************
 * Parameter(s)   :
 * Result(TYPE)   :
 ****************************************************************************************/
// ==> To add your function declare <==

#endif//__UI_H
