/*****************************************************************************************
 * File name     : passwd.h
 * Author        : Han Zhi Qiang
 * Module        : 
 * Purpose       : 
 * Create Date   : November 9, 2001 - 20:58
 * Modify history: 
 *****************************************************************************************
 */

#ifndef __PASSWD_H
#define __PASSWD_H

/*****************************************************************************************
 * Overview
 *****************************************************************************************
 * ==> To add your description <==
 ****************************************************************************************/

/*****************************************************************************************
 * MACRO functions declare
 ****************************************************************************************/

/*****************************************************************************************
 * Identifier constant declare
 ****************************************************************************************/
#define URM_MAXNAMELEN                  16
#define URM_MAXPASSLEN                  10

/*****************************************************************************************
 * Data structure declare
 ****************************************************************************************/
typedef enum
{
  UR_NONE        = 0x00000000l,
  UR_USERMANAGER = 0x00000001l,
  UR_MODIFY      = 0x00000002l,
  UR_VIEW        = 0x00000004l,
  UR_SHUTDOWN    = 0x00000008l,
  UR_ADMIN       = 0xffffffffl
} URM_USERRIGHT;

typedef struct tagURM_USERINFO
{
  CHAR            aszUserName[URM_MAXNAMELEN+1];
  CHAR            aszPassword[URM_MAXPASSLEN+1];
  URM_USERRIGHT   RightMask;
} URM_USERINFO, *URM_PUSERINFO;

typedef struct tagURM_PASSINFO
{
  CHAR            aszOldPass[URM_MAXPASSLEN+1];
  CHAR            aszNewPass[URM_MAXPASSLEN+1];
} URM_PASSINFO, *URM_PPASSINFO;

/*****************************************************************************************
 * Global variable declare
 ****************************************************************************************/

/*****************************************************************************************
 * ==> To add your function declare <==
 *****************************************************************************************
 * ==> To describe the function <==
 *****************************************************************************************
 * Parameter(s)   :
 * Result(TYPE)   :
 ****************************************************************************************/
BOOL AddAdmin (void);
BOOL CheckUser(URM_PUSERINFO pUserInfo);
BOOL ChangeUserPass(PCSTR pcszUserName, URM_PPASSINFO pPassInfo);

BOOL UserEditDlg(HWND hParentWnd, URM_PUSERINFO pUserRight);
BOOL UserLoginDlg(HWND hParantWnd, URM_PUSERINFO pUserRight);
BOOL ChangePasswordDlg(HWND hParantWnd, URM_PPASSINFO pPassInfo);
void UserManagerDlg(HINSTANCE hInst, HWND hWnd);

BOOL LoadUserList(void);
BOOL SaveUserList(void);

#endif//__PASSWD_H
