/*****************************************************************************************
 * File name     : UI.H
 * Author        : Skeleton Key
 * Module        : 
 * Purpose       : 
 * Create Date   : June 8, 2001 - 10:10
 * Modify history: 
 *****************************************************************************************
 */

#ifndef __UI_H
#define __UI_H

/*****************************************************************************************
 * Overview
 *****************************************************************************************
 * ==> To add your description <==
 ****************************************************************************************/

/*****************************************************************************************
 * MACRO functions declare
 ****************************************************************************************/

/*****************************************************************************************
 * Identifier constant declare
 ****************************************************************************************/
#define MAXATCMDLEN                     100

#define ZFZNAMELEN                      50
#define ZFZPHONELEN                     60
#define ZFZREMARKLEN                    100

#define ZFZMAXCHANNEL                   30

/*****************************************************************************************
 * Data structure declare
 ****************************************************************************************/
typedef enum
{
  VWI_NORMAL,
  VWI_ERROR,
  VWI_INSTALL,
  VWI_CONNECT,
  VWI_TURNOFF,
  VWI_RECVMSG,
} VIEWWNDIMAGE;

typedef enum
{
  TASKID_IDLE           = 0x00000000l,
  TASKID_MODIFYPARAM    = 0x00000001l,
  TASKID_GETPROPERTIES  = 0x00000002l,
  TASKID_GETPARAM       = 0x00000004l,
} TASKID;

typedef enum
{
  ERRORCODE_NONE        = 0x00000000l,
  ERRORCODE_VOLTAGE     = 0x00000001l,
  ERRORCODE_CURRENT     = 0x00000002l,
  ERRORCODE_TEMPERATURE = 0x00000004l,
  ERRORCODE_DOOROPEN    = 0x00000008l,
} ERRORCODE;

typedef struct tagMODEMPARAM
{
  WORD            wCommPort;
} MODEMPARAM, *PMODEMPARAM;
typedef const MODEMPARAM* PCMODEMPARAM;

typedef struct tagZFZDATE
{
  WORD            wYear;
  BYTE            bMonth;
  BYTE            bDay;
  BYTE            bHour;
  BYTE            bMinute;
} ZFZDATE, *PZFZDATE;

typedef struct tagZFZCHANNEL
{
  WORD            wFrequency;
  BYTE            bUpGain;
  BYTE            bDownGain;
  BYTE            bUpPower;
  BYTE            bDownPower;
  BYTE            bErrorCode;
  BYTE            bActualUpPower;
  BYTE            bActualDownPower;
} ZFZCHANNEL, *ZFZPCHANNEL;

typedef struct tagZFZPARAM
{
  CHAR            aszName[ZFZNAMELEN+1];
  CHAR            aszPhone[ZFZPHONELEN+1];
  CHAR            aszRemark[ZFZREMARKLEN+1];
  BYTE            bChannels;
  ZFZDATE         CreateDate;
  ZFZDATE         LastAlarmDate;
  ZFZDATE         LastSamplingDate;
  BYTE            fDisableAlarm;
  BYTE            fPowerOnStatus;
  BYTE            fDoorStatus;
  BYTE            bVoltage;
  BYTE            bCurrent;
  BYTE            bTemperature;
  BYTE            bRatedVoltage;
  BYTE            bRatedCurrent;
  BYTE            bRatedTempture;
  BYTE            bRatedPower1;
  BYTE            bRatedPower2;
  BYTE            bRatedUpGain[ZFZMAXCHANNEL];
  BYTE            bRatedDownGain[ZFZMAXCHANNEL];
  ERRORCODE       ErrorCode;
  DWORD           dwLastActionTime;
  TASKID          TaskID;
  TASKID          ExecutedTaskID;
  VIEWWNDIMAGE    VWImageIndex;
//  BYTE            bStatusFlag;
  ZFZCHANNEL      ChannelData[1];
} ZFZPARAM, *PZFZPARAM;

typedef enum
{
  STFLAG_ALWAYSFOCUS   = 0x00000001l,
  STFLAG_TABSTOP       = 0x00000002l,
  STFLAG_IGNORETYPE    = 0x00000004l,
  STFLAG_EXPANDNEWLINE = 0x00000008l,
  STFLAG_INSPECTSTREAM = 0x80000000l,
} STFLAG;

typedef enum
{
  OMPT_SUCCESS,
  OMPT_ERROR,
  OMPT_INFO,
  OMPT_UPLOAD,
  OMPT_DOWNLOAD,
} OMPT;

typedef HWND (PASCAL *STATWND_CREATEWND)(HINSTANCE hInst, HWND hWndParent, STFLAG Flags);
typedef WORD (PASCAL *STATWND_STREAMBYTE)(HWND hWnd, OMPT Type, BYTE bVal);

/*****************************************************************************************
 * Global variable declare
 ****************************************************************************************/
#ifdef ALLOCATE_UI_VARIABLE_MEMORY
  #define UI_VARIABLE_EXTERN
#else
  #define UI_VARIABLE_EXTERN extern
#endif

UI_VARIABLE_EXTERN HINSTANCE  ghInst;
UI_VARIABLE_EXTERN HWND       ghMainWnd;
UI_VARIABLE_EXTERN MODEMPARAM gModemParam;
UI_VARIABLE_EXTERN CHAR       gaszCentrePhone[ZFZPHONELEN+1];
UI_VARIABLE_EXTERN HWND       ghDebugWnd;

UI_VARIABLE_EXTERN STATWND_CREATEWND  gpfunSTATWND_CreateWnd;
UI_VARIABLE_EXTERN STATWND_STREAMBYTE gpfunSTATWND_StreamByte;

/*****************************************************************************************
 * ==> To add your function declare <==
 *****************************************************************************************
 * ==> To describe the function <==
 *****************************************************************************************
 * Parameter(s)   :
 * Result(TYPE)   :
 ****************************************************************************************/
// ==> To add your function declare <==

#endif//__UI_H
